<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `src/api/py/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="stylesheet" type="text/css" href="../../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../../ayu.css" disabled ><script id="default-settings"></script><script src="../../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../../noscript.css"></noscript><link rel="icon" type="image/svg+xml" href="../../../../favicon.svg">
<link rel="alternate icon" type="image/png" href="../../../../favicon-16x16.png">
<link rel="alternate icon" type="image/png" href="../../../../favicon-32x32.png"><style type="text/css">#crate-search{background-image:url("../../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../../HPGO/index.html'><div class='logo-container rust-logo'><img src='../../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu"><img src="../../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices" role="menu"></div></div><script src="../../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" class="help-button">?</button>
                <a id="settings-menu" href="../../../../settings.html"><img src="../../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="kw">use</span> <span class="ident">pyo3</span>::<span class="ident">prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">pyo3</span>::<span class="ident">wrap_pymodule</span>;

<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">py_environment</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">py_hlo_json</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">py_torch_modules</span>;
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">py_utils</span>;

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">api</span>::<span class="ident">py</span>::<span class="ident">py_hlo_json</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">api</span>::<span class="ident">py</span>::<span class="ident">py_torch_modules</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">api</span>::<span class="ident">py</span>::<span class="ident">py_utils</span>::<span class="kw-2">*</span>;

<span class="attribute">#[<span class="ident">pymodule</span>]</span>
<span class="kw">fn</span> <span class="ident">HPGO</span>(<span class="ident">_py</span>: <span class="ident">Python</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>, <span class="ident">m</span>: <span class="kw-2">&amp;</span><span class="ident">PyModule</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">PyResult</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__title__&quot;</span>, <span class="string">&quot;HPGO&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__package__&quot;</span>, <span class="string">&quot;HPGO&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__doc__&quot;</span>, <span class="string">&quot;Hybrid Parallelism Global Orchestration&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__author__&quot;</span>, <span class="string">&quot;Yi Rong &lt;hi@rongyi.io&gt;&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__copyright__&quot;</span>, <span class="string">&quot;Copyright 2020 Yi Rong&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__license__&quot;</span>, <span class="string">&quot;BSD-3-Clause&quot;</span>)<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add</span>(<span class="string">&quot;__version__&quot;</span>, <span class="macro">env</span><span class="macro">!</span>(<span class="string">&quot;CARGO_PKG_VERSION&quot;</span>))<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add_wrapped</span>(<span class="macro">wrap_pymodule</span><span class="macro">!</span>(<span class="ident">torch_modules</span>))<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add_wrapped</span>(<span class="macro">wrap_pymodule</span><span class="macro">!</span>(<span class="ident">hlo_json</span>))<span class="question-mark">?</span>;
    <span class="ident">m</span>.<span class="ident">add_wrapped</span>(<span class="macro">wrap_pymodule</span><span class="macro">!</span>(<span class="ident">Utils</span>))<span class="question-mark">?</span>;

    <span class="prelude-val">Ok</span>(())
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../../";window.currentCrate = "HPGO";</script><script src="../../../../main.js"></script><script src="../../../../source-script.js"></script><script src="../../../../source-files.js"></script><script defer src="../../../../search-index.js"></script></body></html>